=== src/tools/CMakeLists.txt ===
if(LIBUNICODE_TOOLS)
    add_executable(unicode-query unicode-query.cpp)
    target_link_libraries(unicode-query unicode)
    if(LIBUNICODE_BUILD_STATIC)
        target_link_libraries(unicode-query "-static")
    endif()
    install(TARGETS unicode-query DESTINATION bin)
endif()
