=== debian/changelog ===
libunicode (0.6.0-1) unstable; urgency=medium

  * Initial release

 -- April Lu <apr3vau@outlook.com>  Tue, 01 Jul 2025 14:48:25 +0800
