=== debian/control ===
Source: libunicode
Priority: optional
Maintainer: April Lu <apr3vau@outlook.com>
Build-Depends: debhelper-compat (= 13), cmake, g++-13, catch2, librange-v3-dev, python3
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/contour-terminal/libunicode
Rules-Requires-Root: no

Package: libunicode-dev
Section: libdevel
Architecture: any
Depends: libunicode0.6 (= ${binary:Version}), ${misc:Depends}
Description: Modern C++20 Unicode library
 The goal of this library is to bring painless unicode support to C++ with
 simple and easy to understand APIs.

Package: libunicode0.6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Modern C++20 Unicode library
 The goal of this library is to bring painless unicode support to C++ with
 simple and easy to understand APIs.
