=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=None \
		-DLIBUNICODE_TESTING=OFF \
		-DCMAKE_CXX_COMPILER=g++-13
