=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libunicode-$1.tar.gz%" \
   https://github.com/contour-terminal/libunicode/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
